"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Coordinator = void 0;
var utils_1 = require("./utils");
var async_mqtt_1 = __importDefault(require("async-mqtt"));
var STSensor_1 = require("./Sensors/STSensor");
var Coordinator = /** @class */ (function () {
    function Coordinator() {
        this.usedAddresses = new Array();
        this.usedMcuIds = new Array();
        this.sensors = new Array();
    }
    Coordinator.prototype.generateAddress = function () {
        var address;
        do {
            address = (0, utils_1.randomNumberInRange)(1, 65535);
        } while (this.usedAddresses.indexOf(address) != -1);
        this.usedAddresses.push(address);
        return "0x" + (0, utils_1.decToHex)(address);
    };
    Coordinator.prototype.generateMcuId = function () {
        var mcuId;
        do {
            mcuId = (0, utils_1.randomNumberInRange)(1, 4294967295);
        } while (this.usedMcuIds.indexOf(mcuId) != -1);
        this.usedMcuIds.push(mcuId);
        return "0x" + (0, utils_1.decToHex)(mcuId);
    };
    Coordinator.prototype.addSensor = function (type) {
        switch (type) {
            case 'STSensor':
                this.sensors.push(new STSensor_1.STSensor(this.generateAddress(), this.generateMcuId()));
                break;
            default:
                console.log("Invalid sensor type.");
                break;
        }
        return this;
    };
    Coordinator.prototype.getData = function () {
        return this.sensors.map(function (sensor) {
            var data = sensor.getData();
            return data;
        });
    };
    Coordinator.prototype.publishData = function (interval, broker) {
        var _this = this;
        if (interval === void 0) { interval = 7500; }
        if (broker === void 0) { broker = "broker.emqx.io"; }
        var mqttClient = async_mqtt_1.default.connect("mqtt://" + broker).on('connect', function () { return console.log("[MQTT] Connected to " + broker + "."); });
        setInterval(function () {
            try {
                _this.sensors.map(function (sensor) { return __awaiter(_this, void 0, void 0, function () {
                    var sensorData;
                    return __generator(this, function (_a) {
                        sensorData = sensor.getData();
                        if (Array.isArray(sensorData)) {
                            sensorData.map(function (data) {
                                if (Array.isArray(data))
                                    data.map(function (dataItem) {
                                        return mqttClient.publish(dataItem.Type + "/" + dataItem.DevAddr, JSON.stringify(dataItem));
                                    }); // sensorData is of type DataObject[][]
                                else
                                    mqttClient.publish(data.Type + "/" + data.DevAddr, JSON.stringify(data)); // sensorData is of type DataObject[]
                            });
                        }
                        else
                            mqttClient.publish(sensorData.Type + "/" + sensorData.DevAddr, JSON.stringify(sensorData)); // sensorData is of DataObject type 
                        return [2 /*return*/];
                    });
                }); });
            }
            catch (error) {
                console.log(error);
            }
        }, interval);
    };
    return Coordinator;
}());
exports.Coordinator = Coordinator;
