"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BatterySensor = void 0;
var utils_1 = require("../utils");
var BatterySensor = /** @class */ (function () {
    function BatterySensor(devAddr, mcuId) {
        this.devAddr = devAddr;
        this.mcuId = mcuId;
        this.type = "Battery";
    }
    BatterySensor.prototype.getData = function () {
        return {
            DevAddr: this.devAddr,
            Type: this.type,
            MCU_ID: this.mcuId,
            Level: (0, utils_1.randomNumberInRange)(0.0, 100.0, false) + "%",
            Voltage: (0, utils_1.randomNumberInRange)(0, 5000),
            Unit: "mV"
        };
    };
    return BatterySensor;
}());
exports.BatterySensor = BatterySensor;
