"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.STSensor = void 0;
var BatterySensor_1 = require("./BatterySensor");
var TemperatureSensor_1 = require("./TemperatureSensor");
var VelocitySensor_1 = require("./VelocitySensor");
var STSensor = /** @class */ (function () {
    function STSensor(devAddr, mcuId) {
        this.devAddr = devAddr;
        this.mcuId = mcuId;
        this.batterySensor = new BatterySensor_1.BatterySensor(devAddr, mcuId);
        this.temperatureSensor = new TemperatureSensor_1.TemperatureSensor(devAddr, mcuId);
        this.velocitySensor = new VelocitySensor_1.VelocitySensor(devAddr, mcuId);
    }
    STSensor.prototype.getData = function () {
        return [this.temperatureSensor.getData(), this.batterySensor.getData(), this.velocitySensor.getData()];
    };
    return STSensor;
}());
exports.STSensor = STSensor;
