"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.randomNumberInRange = exports.decToHex = void 0;
var hexMap = {
    0: "0",
    1: "1",
    2: "2",
    3: "3",
    4: "4",
    5: "5",
    6: "6",
    7: "7",
    8: "8",
    9: "9",
    10: "A",
    11: "B",
    12: "C",
    13: "D",
    14: "E",
    15: "F"
};
var decToHex = function (origin) {
    if (origin <= 15)
        return hexMap[origin];
    var result = new Array();
    while (origin > 0) {
        var remainder = Math.floor(origin % 16);
        result.push(hexMap[remainder]);
        origin = Math.floor(origin / 16);
    }
    return result.reverse().join("");
};
exports.decToHex = decToHex;
var randomNumberInRange = function (min, max, round) {
    if (round === void 0) { round = true; }
    if (round) {
        min = Math.ceil(min);
        max = Math.floor(max);
        return Math.floor(Math.random() * (max - min + 1) + min); //The maximum is inclusive and the minimum is inclusive
    }
    var generatedValueToString = (Math.random() * (max - min + 1) + min).toString();
    var dotIndex = generatedValueToString.indexOf(".");
    return parseFloat(generatedValueToString.substring(0, dotIndex + 3));
};
exports.randomNumberInRange = randomNumberInRange;
